package com.hamaf.hikyaku.dataobject;

import java.util.HashMap;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.Map;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import javax.servlet.http.HttpSession;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.TextUtil;


/**
 * <p>^CgFCommonMessage is Based Message Chargo Object.</p>
 * <p>F{̃bZ[WۊǗpNXłB</p>
 * <br>ۊǂ鍀ڂ͈ȉ̍ڂłB
 * <ul>
 *   <li>G[ԃR[h@F@NORMAL,CAUTION,WARNING,ERROR ̂ꂩݒ肷
 *   <li>bZ[WXg@F@bZ[WȂǂ郊Xg̈ &lt;String&gt;
 *   <li>NGXge[uF@HttpRequest̒lȂǂMap̈ &lt;String, String&gt;
 *   <li>X|Xe[uF@\p̍ڂݒ肷Map̈ &lt;String, String&gt;
 *   <li>X|XXg@F@ꗗp̍ڂݒ肷Lisẗ &lt;Map&lt;String, String&gt;&gt;
 *   <li>X|XpGAF@CӂObjectێ郏[N̈
 *   <li>ZbVGA@F@HttpSessionێ̈
 *   <li>SysID  F@VXeIDێ̈
 *   <li>CharCd F@R[hێ̈
 * </ul>
 * ëɑ΂ݒA擾\bh͗pӂĂ܂B
 * <br>iterator()ŃX|XXgIterator߂܂B
 *
 * <br>lۊǂ邽߂̃NXŁAȊÔƂ͍s܂B
 *
 * <p>쌠: Copyright (c) 2003/12/01</p>
 * @author Hamanaka
 * @version 1.0
 */
public class CommonMessage implements Iterable<Map<String, String>> {

  /**
   * errorStatus value definition.
   */
  public enum STATUS {NORMAL, CAUTION, WARNING, ERROR};

  /**
   * G[ԂtB[h
   */
  private STATUS _errorStatus;

  /**
   * bZ[Wݒp̗̈
   */
  private List<String> _messages = new ArrayList<String>();

  /**
   * NGXgp[^p̗̈
   */
  private Map<String, String> _httpReq = new HashMap<String, String>();

  /**
   * X|Xp̗̈
   */
  private Map<String, String> _resMessage = new HashMap<String, String>();
  private List<Map<String, String>> _resList = new ArrayList<Map<String, String>>();
  private Object _workBuff = null;

  /**
   * HttpZbVp̗̈
   */
  private HttpSession _session = null;

  /**
   * SysId ۑ̈
   */
  private String _sysId;
  
  /**
   * Characte Encode ۑ̈ 
   */
  private String _charCd;
  
  /**
   * stH_[pX̕ۑ̈ 
   */
  private String _appRoot;

  /**
   *  Creates a new <code>CommonMessage.java</code> instance.
   * <br>Default Constructor
   *
   */
  public CommonMessage() {
  }

  // --------------- Getter,Setter Discription ----------------
  /**
   * Describe <code>getErrorStatus</code> method : ErrorStatus getter.
   * <br>G[ԃR[h̎擾
   * @return an <code>STATUS</code> : G[ԃR[h
   */
  public final STATUS getErrorStatus() {
    return _errorStatus;
  }

  /**
   * Describe <code>setErrorStatus</code> method : ErrorStatus setter.
   * <br>G[ԃR[h̐ݒ
   * @param errorStI an <code>int</code> : G[ԃR[h
   */
  public final void setErrorStatus(STATUS errorStI) {
    _errorStatus = errorStI;
  }

  /**
   * Describe <code>getSession</code> method : HttpSession gette.
   * <br>HttpSession̎擾
   * @return a <code>HttpSession</code> : HttpSession
   */
  public final HttpSession getSession() {
    return _session;
  }

  /**
   * Describe <code>setSession</code> method : HttpSession setter.
   * <br>HttpSession̐ݒ
   * @param session a <code>HttpSession</code> : HttpSession
   */
  public final void setSession(HttpSession session) {
    _session = session;
  }

  /**
   * Describe <code>getMessages</code> method : messageList getter.
   * <br>bZ[WXg̎擾
   * @return a <code>List</code> : bZ[WXg
   */
  public final List<String> getMessages() {
    return _messages;
  }

  /**
   * Describe <code>setMessages</code> method : messageList setter.
   *@<br>bZ[WXg̐ݒ
   * @param messages a <code>List</code> : bZ[WXg
   */
  public final void setMessages(List<String> messages) {
    _messages = messages;
  }

  /**
   * Describe <code>getHttpReq</code> method : httpReq getter.
   * <br>NGXge[u̎擾
   * @return a <code>Map</code> : NGXge[u
   */
  public final Map<String, String> getHttpReq() {
    return _httpReq;
  }

  /**
   * Describe <code>setHttpReq</code> method : httpReq setter.
   * <br>NGXge[u̐ݒ
   * @param httpReq a <code>Map</code> : NGXge[u
   */
  public final void setHttpReq(Map<String, String> httpReq) {
    _httpReq = httpReq;
  }

  /**
   * Describe <code>getResMessage</code> method : resMessage getter.
   * <br>X|Xe[u̎擾
   * @return a <code>Map</code> : X|Xe[u
   */
  public final Map<String, String> getResMessage() {
    return _resMessage;
  }

  /**
   * Describe <code>setResMessage</code> method : resMessage setter.
   * <br>X|Xe[u̐ݒ
   * @param resMessage a <code>Map</code> : X|Xe[u
   */
  public final void setResMessage(Map<String, String> resMessage) {
    _resMessage = resMessage;
  }

  /**
   * Describe <code>getResList</code> method : resList getter.
   * <br>X|XXg̎擾
   * @return a <code>List</code> : X|XXg
   */
  public final List<Map<String, String>> getResList() {
    return _resList;
  }

  /**
   * Describe <code>setResList</code> method : resList setter.
   * <br>X|XXg̐ݒ
   * @param argList a <code>List</code> : X|XXg
   */
  public final void setResList(List<Map<String, String>> argList) {
    _resList = argList;
  }

  /**
   * Get the <code>SysId</code> value.
   *
   * @return a <code>String</code> : 
   */
  public final String getSysId() {
    return _sysId;
  }

  /**
   * Set the <code>SysId</code> value.
   *
   * @param newSysId The new SysId value.
   */
  public final void setSysId(final String newSysId) {
    this._sysId = newSysId;
  }

  /**
   * @return charCd
   */
  public final String getCharCd() {
    return _charCd;
  }

  /**
   * @param charCd : charCd ݒ肵܂B
   */
  public final void setCharCd(String charCd) {
    _charCd = charCd;
  }

  /**
   * @return workBuff
   */
  public final Object getWorkBuff() {
    return _workBuff;
  }

  /**
   * @param workBuff : workBuff ݒ肵܂B
   */
  public final void setWorkBuff(Object workBuff) {
    _workBuff = workBuff;
  }

  /**
   * @return appRoot 擾܂B
   */
  public final String getAppRoot() {
    return _appRoot;
  }

  /**
   * @param appRoot appRoot ݒ肵܂B
   */
  public final void setAppRoot(String appRoot) {
    _appRoot = appRoot;
  }

  //---------- public methods definition ------------------
  /**
   * Describe <code>addMessage</code> method : add Message List.
   * <br>bZ[WpXgɃbZ[WǉB
   * <br>JSPł̕\pɃR[hϊA^Oϊs܂B
   */
  public void addMessage(String msg) {
    _messages.add(TextUtil.cnvJsp(msg, _charCd));
  }
  
  /**
   * Describe <code>magIterator</code> method : return MessageList Iterator.
   * <br>bZ[WXg̃Ce[^ԋpB
   * @return a <code>Iterator</code> : bZ[WXgIterator
   */
  public final Iterator<String> msgIterator() {
    return _messages.iterator();
  }
  /**
   * Describe <code>setReq</code> method : set HttpReqMap item.
   * <br>NGXge[uɍڂݒ肵܂B
   * @param key a <code>String</code> : ݒ肷鍀ڂ̃L[l
   * @param val an <code>String</code> : ݒ肷l
   */
  public void setReq(String key, String[] vals) {
    StringBuilder val = new StringBuilder();
    for (int i=0; i < vals.length; i++) {
      val.append(ComUtils.sun2win(vals[i], _charCd));
      val.append("\t");
    }
    if (val.length() > 0) {
      val.setLength(val.length() - 1);
    }
    _httpReq.put(key, val.toString());
  }
  /**
   * Describe <code>getReqValus</code> method : get HttpReqMap item.
   * <br>NGXge[uL[lŎw肳ꂽڂStringz߂܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> :  : L[lɑΉڂ String[] l
   */
  public String[] getReqValus(String key) {
    String rval = getReq(key);
    if (rval == null) {
      return null;
    }
    return rval.split("\t");
  }
  /**
   * Describe <code>getReq</code> method : get HttpReqMap item and toString().
   * <br>NGXge[uL[lŎw肳ꂽڂ̒l߂܂B
   * <br>lObjectStringz̏ꍇ<code>tab</code>ŐڑĖ߂܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> :  : L[lɑΉڂ String l
   */
  public String getReq(String key) {
    return _httpReq.get(key);
  }
  /**
   * Describe <code>getReqStr</code> method : .
   * <br>NGXge[uL[lŎw肳ꂽڂ̒l߂܂B
   * <br>L[l݂Ȃꍇ͒0̕("")߂܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> :  : L[lɑΉڂ String l
   */
  public String getReqStr(String key) {
    String ret = getReq(key);
    if (ret == null) return "";
    return ret;
  }
  /**
   * Describe <code>getReq4JSP</code> method : get HttpReqMap item for JSP.
   * <br>NGXge[uL[lŎw肳ꂽڂ̒l߂܂B
   * <br>JSPł̕\pɃR[hϊA^Oϊs܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> :  : L[lɑΉڂ JSPp̒l
   */
  public String getReq4JSP(String key) {
    return TextUtil.cnvJsp(getReqStr(key), _charCd);
  }
  /**
   * Describe <code>getReqKeys</code> method : return key set.
   * <br>NGXge[ũL[l̔z<code>(Set)</code>߂܂B
   * @return a <code>Set</code> : L[l̔z
   */
  public final Set<String> getReqKeys() {
    return _httpReq.keySet();
  }
  /**
   * Describe <code>setResMsg</code> method : set resMessage item.
   * <br>X|XbZ[Wɍڒlݒ肵܂B
   * @param key a <code>String</code> : ݒ肷鍀ڂ̃L[l
   * @param val a <code>String</code> : ݒ肷鍀ڂ̒l
   */
  public void setResMsg(String key, String val) {
    _resMessage.put(key, val);
  }
  /**
   * Describe <code>getResMsg</code> method : get resMessage item..
   * <br>X|XbZ[WL[lŎw肳ꂽڂ擾܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> : L[lɑΉl
   */
  public String getResMsg(String key) {
    return _resMessage.get(key);
  }
  /**
   * Describe <code>getResMsg4JSP</code> method : get resMessage item and toString().
   * <br>X|XbZ[WL[lŎw肳ꂽڂ<code>toString()</code>l߂܂B
   * <br>JSPł̕\pɃR[hϊA^Oϊs܂B
   * @param key a <code>String</code> : 擾l̃L[l
   * @return a <code>String</code> :  : L[lɑΉڂ JSPp̒l
   */
  public String getResMsg4JSP(String key) {
    return TextUtil.cnvJsp(getResMsg(key), _charCd);
  }
  /**
   * Describe <code>getResMsgKeys</code> method : return key set.
   * <br>X|XbZ[W̃L[l̔z<code>(Set)</code>߂܂B
   * @return a <code>Set</code> : L[l̔z
   */
  public final Set<String> getResMsgKeys() {
    return _resMessage.keySet();
  }
  /**
   * Describe <code>addResList</code> method : add resList List.
   * <br>X|XpXgɈꗗ\p̍ڂǉB
   * 
   * @param obj a <code>Map</code> : Map`̈ꗗ\
   */
  public void addResList(Map<String, String> obj) {
    _resList.add(obj);
  }
  /**
   * Describe <code>resIterator</code> method : return resList List Iterator.
   * <br>X|XpXg̃XgCe[^ԋpB
   * @return a <code>Iterator</code> : X|XpXgIterator
   */
  public final ListIterator<Map<String, String>> iterator() {
    return _resList.listIterator();
  }

  /**
   * Describe <code>resSize</code> method : return resList size.
   * <br>X|XpXg̃TCYԋpB
   * @return a <code>int</code> : X|XpXgsize
   */
  public final int resSize() {
    return _resList.size();
  }
  //---------- toString Methods ----------------------
  /**
   * Describe <code>toErrorString</code> method : Error Message String.
   * <br>G[̕\߂܂B
   * @return a <code>String</code> : G[̕\
   */
  public String toErrorString() {
    StringBuilder sb = new StringBuilder();
    sb.append("\nPlugin Id is ");
    sb.append(_sysId);
    sb.append("\nCharacter Encode is ");
    sb.append(_charCd);
    sb.append("\nError Status is ");
    sb.append(_errorStatus);
    sb.append(".\n==== Message Value ==== \n");
    for (String element : _messages) {
      sb.append(element);
      sb.append("\n");
    }
    sb.append("===== End Message Value ====\n");
    return sb.toString();
  }

  /**
   * Describe <code>toRequestString</code> method : Request Map String.
   * <br>NGXgMap̕\߂܂B
   * @return a <code>String</code> : NGXgMap̕\
   */
  public String toRequestString() {
    StringBuilder sb = new StringBuilder();
    sb.append("\n=== Request Map Value === \n");
    for (String element : _httpReq.keySet()) {
      sb.append(element);
      sb.append(" = '");
      sb.append(getReq4JSP(element));
      sb.append("'\n");
    }
    sb.append("===== End Map Value =====\n");
    return sb.toString();
  }

  /**
   * Describe <code>toResponseString</code> method : Response Map,List String.
   * <br>X|XMap,List̕\߂܂B
   * @return a <code>String</code> : X|XMap,List̕\
   */
  public String toResponseString() {
    StringBuilder sb = new StringBuilder();
    sb.append("\n=== Response Map Value === \n");
    for (String element : _resMessage.keySet()) {
      sb.append(element);
      sb.append(" = '");
      sb.append(_resMessage.get(element));
      sb.append("'\n");
    }
    sb.append("=== Response List Value === \n");
    for (Map<String, String> val : _resList) {
      sb.append(val);
      sb.append("\n");
    }
    sb.append("=== End Response Value ====\n");
    sb.append("WorkBuffer = '");
    if (_workBuff != null) {
      sb.append(_workBuff.toString());
    }
    sb.append("'\n");
    return sb.toString();
  }

}
