package com.hamaf.hikyaku.distribute;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * <p>^CgFProcessLogger is Oo̓NX.</p>
 * <p>F<b>DistributeServlet</b>gp郍Oo̓NXłB</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2007/05/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ServletLogger {

  private static final String LOGP = "LogOut";

  private DistributeServlet _parent = null;
  private ResourceBundle _resource = null;
  private String _val = null;

  /**
   *  Creates a new <code>ProcessLogger.java</code> instance.
   * <br>Default Constructor
   * @param parent
   */
  public ServletLogger(DistributeServlet parent) {
    init(parent);
  }
  
  private void init(DistributeServlet parent) {
    _parent = parent;
    _resource = parent.getResource();
    _val = _parent.getInitParameter(LOGP);
    
    logPut("init", 2);

    if (_val != null && _val.toLowerCase().equals("yes")) {
      logPut(_resource.getString("setLogPut"), 1);
    }
    if (_val != null && _val.toLowerCase().equals("all")) {
      logPut(_resource.getString("setLogPut"), 2);
    }    
  }

  /**
   * Describe <code>logPut</code> method : if logout then logging output.
   * <br>logout̒lݒ肳ĂƂɁAOւ̃bZ[Wo͂s܂B
   * <br>o̓xlogout̒lȉ̃bZ[Ŵݏo͂܂B
   * @param msg a <code>void</code> : o͂郁bZ[W
   * @param lvl an <code>int</code> : bZ[W̏o̓x
   */
  public void logPut(String msg, int lvl) {
    if (cnvLvl() >= lvl) {
      String outm = msg;
      try {
        outm =_resource.getString(msg);
      } catch (MissingResourceException me) {
      }
      _parent.log(outm);
    }
  }
  
  /**
   * Describe <code>chkLvl</code> method : conversion Log Out LEVEL.
   * <br>Ȍo̓x߂B
   * 
   * @return a <code>int</code>
   */
  private int cnvLvl() {
    String val = _parent.getInitParameter(LOGP);
    if (val != null && val.toLowerCase().equals("yes")) {
      return 1;
    }
    if (val != null && val.toLowerCase().equals("all")) {
      return 2;
    }
    return 0;
  }

}
