package com.hamaf.hikyaku.extension;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>^CgFAppLogOutFactory is AppLogOut class Factory.</p>
 * <p>FAppLogOutSystemIdɂێB</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2007/05/23</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class AppLogOutFactory {
  
  private Map<String, AppLogOut> _logObj = new HashMap<String, AppLogOut>();
  private static AppLogOutFactory _myObj = new AppLogOutFactory();
  
  private AppLogOutFactory() {  }
  public static AppLogOutFactory getInstance() {
    return _myObj;
  }
  
  /**
   * Describe <code>setAppLog</code> method : save AppLogOut.
   * <br>AppLogOut class sysIdŕێB
   * 
   * @param sysId a <code>String</code> : 
   */
  public final void setAppLog(String pid) {
    AppLogOutImpl aoi = new AppLogOutImpl();
    aoi.setLevel(pid);
    _logObj.put(pid, aoi);
  }
  
  /**
   * Describe <code>getAppLog</code> method : return AppLogOut.
   * <br>w肵sysIdŕێĂAppLogOut߂B
   * 
   * @param sysIda <code>String</code> : 
   * @return a <code>AppLogOut</code> : 
   */
  public final AppLogOut getAppLog(String sysId) {
    return _logObj.get(sysId);
  }
}
