package com.hamaf.hikyaku.extension;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.ItemChecks;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFRetrieveUnitCheck Class.</p>
 * <p>FڂW̍ڃ`FbNŃ`FbNsB</p>
 * <br>pӂ郁\bhiS <b>static</b> Ŏj
 * <ul>
 *   <li>retItemCheck - ڃ`FbNsB
 * </ul>
 *
 * <p>쌠: Copyright (c) 2004/07/22</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class RetrieveUnitCheck {

  /**
   *  Creates a new <code>RetrieveUnitCheck.java</code> instance.
   * <br>Default Constructor
   *
   */
  public RetrieveUnitCheck() {
  }

  /**
   * Describe <code>retItemCheck</code> method : Unit Item Check.
   * <br>ڂ̍ڃ`FbNsB
   * <br>G[̏ꍇAO(<code>IllegalRetrieveDataException</code>)𓊂܂B
   * @param key a <code>KeyList</code> : `FbNKeyList oObject
   * @param folder a <code>String</code> : ڃ`FbNŎgptH_[
   * @throws IllegalRetrieveDataException
   */
  public static final void retItemCheck(KeyList key, String folder)
   throws IllegalRetrieveDataException {
    CommonMessage cms = new CommonMessage();
    cms.setCharCd(key.getCharCD());
    cms.setSysId(key.getSysId());
    Map<String, String> km = key.getRetrieveAll();
    Set<String> kset = km.keySet();
    for (String keynm : kset) {
      String[] dt = {keynm};
      cms.setReq(keynm, dt);
    }
    ItemChecks itc = new ItemChecks();
    cms = itc.check(cms, folder);
    if (cms.getErrorStatus() == STATUS.NORMAL) {
      return;
    }
    Map<String, String> emp = new HashMap<String, String>();
    Set<String> itm = cms.getResMsgKeys();
    for (String keynm : itm) {
      emp.put(keynm, cms.getResMsg(keynm));
    }
    throw new IllegalRetrieveDataException("unit check error", emp);
  }


}
