package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.plugIn.dto.VInitDto;
import com.hamaf.hikyaku.plugIn.process.InitInfAcquisition;
import com.hamaf.hikyaku.plugIn.ui.mapping.InitViewMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFInitModIni is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/23</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class InitModIni extends StandardDetailProcess {

  private InitInfAcquisition _iia = null;
  /**
   *  Creates a new <code>InitModIni.java</code> instance.
   * <br>Default Constructor
   */
  public InitModIni(InitViewMap ivm, InitInfAcquisition iia) {
    _jim = ivm;
    _iia = iia;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _iia.findByPrimarykey((VInitDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VInitDto();
  }

}
