package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.process.RegisterPlugIn;
import com.hamaf.hikyaku.plugIn.ui.mapping.PluginInfMap;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFPluginDelete</p>
 * <p>FvOC폜ʏ</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/01/26</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PluginDelete extends StandardUpdateProcess {

  private RegisterPlugIn _rp;
  /**
   *  Creates a new <code>PluginDelete.java</code> instance.
   * <br>Default Constructor
   */
  public PluginDelete(PluginInfMap pim, RegisterPlugIn rp) {
    _jim = pim;
    _rp = rp;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    msg.setResMsg("PluginDel", "1");
    _rp.delete((PluginInfDto)dii);
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new PluginInfDto();
  }

}
