package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.plugIn.access.PluginAccess;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.ui.mapping.PluginInfMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFPluginDeleteIni.</p>
 * <p>FvOC擾B</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/12</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PluginDeleteIni extends StandardDetailProcess {

  private PluginAccess _pa = null;
  /**
   *  Creates a new <code>PluginDeleteIni.java</code> instance.
   * <br>Default Constructor
   */
  public PluginDeleteIni(PluginInfMap pim, PluginAccess pa) {
    _jim = pim;
    _pa = pa;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _pa.findByPrimaryKey(dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new PluginInfDto();
  }

}
