package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.VGroupDto;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.security.ui.mapping.VGroupInfMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFDroupModIni is .</p>
 * <p>FO[v̏ڍ׏擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/05/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupModIni extends StandardDetailProcess {

  private GroupProcess _gp = null;

  /**
   *  Creates a new <code>DroupModIni.java</code> instance.
   * <br>Default Constructor
   * @param gp
   * @param jim
   */
  public GroupModIni(GroupProcess gp, VGroupInfMap jim) {
    _gp = gp;
    _jim = jim;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gp.findByPrimarykey((VGroupDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VGroupDto();
  }

}
