package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFUserModIni is .</p>
 * <p>F[U[̎擾</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/03/17</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserModIni extends StandardDetailProcess {

  private UserProcess _up = null;

  /**
   *  Creates a new <code>UserModIni.java</code> instance.
   * <br>Default Constructor
   */
  public UserModIni(UserInfMap uim, UserProcess up) {
    _jim = uim;
    _up = up;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      dii.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    return _up.findByPrimarykey((UserDto)dii, session);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }

}
