package com.hamaf.hikyaku.taglibs;

import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: }X^XmlR[hɑΉl擾^uu.</p>
 * <p>: }X^XMLw肵q^O̓e߂܂B</p>
 * <br>q^O
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>tag</td>
 *     <td>K{</td>
 *     <td>^Ow肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>ΉCommonMessage̍ږw肷B̒lɑΉ閼̂߂܂B</td>
 *   </tr>
 *   <tr>
 *     <td>child</td>
 *     <td>C</td>
 *     <td>q^Ô̖w肷Bw肪ꍇ͖̂擾܂B</td>
 *   </tr>
 * </table>
 *
 *
 * <p>쌠: Copyright (c) 2004/07/27</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class Master2Dsp extends TagSupport {

  private static final long serialVersionUID = 8695199974655490814L;

  private String _item = null;
  private String _tag = null;
  private String _child = null;


  /**
   * ^OJnɌĂяo
   *
   * @return <code>EVAL_BODY_INCLUDE</code>
   * @throws JspException
   */
  public int doStartTag() throws JspException {
    //l̊mF
    if (_tag == null || _item == null) {
      return SKIP_BODY;
    } // end of if (tag is null)

    String val = MessageUtil.getItem(pageContext.getRequest(), _item, false);
    if (val.length() == 0) {
      val = MessageUtil.getKeyItem(pageContext.getSession(), _item);
    }
    if (val == null || val.length() == 0) {
      return SKIP_BODY;
    }

    String sysId = (String)pageContext.getRequest().getAttribute(DistributeServlet.PLUGIN_ID);
    MasterXmlControl mxs = MasterXmlFactory.newInstance().getMasterXml(sysId);
    Map<String, String> mdt = mxs.getItemValue(_tag, val);
    if (_child == null) {
      StringBuilder sb = new StringBuilder();
      sb.append(_tag);
      sb.append("Name");
      _child = sb.toString();
    }

    try {
      pageContext.getOut().println(mdt.get(_child));
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
    release();

    return SKIP_BODY;
  }

  /**
   * ^OIɌĂяo.
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }

  /**
   * <CODE>item</CODE>̐ݒ.
   * @param item Value to assign to (String)_item.
   */
  public final void setItem(String item) {
    _item = item;
  }

  /**
   * <CODE>tag</CODE>̐ݒ.
   * @param tag Value to assign to (String)_tag.
   */
  public final void setTag(String tag) {
    _tag = tag;
  }

  /**
   * <CODE>child</CODE>̐ݒ.
   * @param child Value to assign to (String)_child.
   */
  public final void setChild(String child) {
    _child = child;
  }

  /**
   * ^O̓ԂZbg
   */
  public void release() {
    _item = null;
    _tag = null;
    _child = null;
    super.release();
  }

}
