package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;
import java.util.List;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.util.MessageUtil;

/**
 * <p>^Cg: }X^Xml<b>option</b>𐶐^uu.</p>
 * <p>: }X^XML&lt;option value="_code_"&gt;&lt;/option&gt; 𐶐B</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>tag</td>
 *     <td>K{</td>
 *     <td>^Ow肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>C</td>
 *     <td>ΉCommonMessage̍ږw肷B<br>vl<b>selected</b>ݒ肳܂B</td>
 *   </tr>
 *   <tr>
 *     <td>ini</td>
 *     <td>C</td>
 *     <td>lw肷B</td>
 *   </tr>
 *   <tr>
 *     <td>blnk</td>
 *     <td>C</td>
 *     <td>󔒂쐬B</td>
 *   </tr>
 * </table>
 *
 * <p>쌠: Copyright (c) 2004/05/03</p>
 * @author Hamanaka
 * @version 1.0
 */
public class Master2Opt extends TagSupport {

  private static final long serialVersionUID = 8043280606584877061L;
  private static final String OPTTAG = "<option value=\"{0}\"{2}>{1}</option>\n";
  private static final String[] BLKDT = {"", " "};
  private static final String ATRSEL = " selected";

  private String _item = null;
  private String _tag = null;
  private String _ini = null;
  private String _blnk = null;

  /**
   * ^OJnɌĂяo
   *
   * @return <code>EVAL_BODY_INCLUDE</code>
   * @throws JspException
   */
  public int doStartTag() throws JspException {
    //l̊mF
    if (_tag == null ) {
      return SKIP_BODY;
    } // end of if (tag is null)
    String sysId = (String)pageContext.getRequest().getAttribute(DistributeServlet.PLUGIN_ID);
    MasterXmlControl mxs = MasterXmlFactory.newInstance().getMasterXml(sysId);
    List<String[]> al = mxs.getItemsList(_tag);
    if (_blnk != null) {
      al.add(0, BLKDT);
    }
    String val = getValue(_item, _ini);

    for (String[] dt : al) {
      Object[] prm = new Object[3];
      System.arraycopy(dt, 0, prm, 0, 2);
      prm[2] = checkSelected(val, dt[0]);
      try {
        pageContext.getOut().println(MessageFormat.format(OPTTAG, prm));
      } catch (Exception ioe) {
        throw new JspException(ioe.getMessage());
      }
    } // end of for (Iterator it = al.iterator(); .hasNext();)
    release();
    return SKIP_BODY;
  }

  private String getValue(String item, String ini) {
    String val = MessageUtil.getItem(pageContext.getRequest(), _item, false);
    if (val.length() == 0) {
      val = MessageUtil.getKeyItem(pageContext.getSession(), _item);
    }
    if (val == null || val.length() == 0) {
      if (_ini == null) {
        val = "";
      }
      else {
        val = _ini;
      }
    }
    return val.toLowerCase();
  }
  private String checkSelected(String org, String dt) {
    if (org.equals(dt.toLowerCase())) {
      return ATRSEL;
    }
    return "";
  }

  /**
   * ^OIɌĂяo.
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }

  /**
   * <CODE>item</CODE>̐ݒ.
   * @param item Value to assign to (String)_item.
   */
  public final void setItem(String item) {
    _item = item;
  }

  /**
   * <CODE>tag</CODE>̐ݒ.
   * @param tag Value to assign to (String)_tag.
   */
  public final void setTag(String tag) {
    _tag = tag;
  }

  /**
   * <CODE>ini</CODE>̐ݒ.
   * @param ini Value to assign to (String)_ini.
   */
  public final void setIni(String ini) {
    _ini = ini;
  }

  /**
   * @param blnk blnk ݒ肵܂B
   */
  public final void setBlnk(String blnk) {
    _blnk = blnk;
  }

  /**
   * ^O̓ԂZbg
   */
  public void release() {
    _item = null;
    _tag = null;
    _ini = null;
    _blnk = null;
    super.release();
  }

}
