package com.hamaf.hikyaku.taglibs;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.util.MessageUtil;


/**
 * <p>^Cg: eLXgGAtB[hp^OuNX.</p>
 * <p>: &lt;textarea ... &gt;...&lt;/textarea&gt; ^O𐶐Ė߂B</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>item</td>
 *     <td>K{</td>
 *     <td>鍀ږw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>rows</td>
 *     <td>K{</td>
 *     <td><b>rows</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>cols</td>
 *     <td>K{</td>
 *     <td><b>cols</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>read</td>
 *     <td>C</td>
 *     <td><b>readonly</b>̏ꍇw肵܂B(l<code>null</code>ȊO)</td>
 *   </tr>
 *   <tr>
 *     <td>cls</td>
 *     <td>C</td>
 *     <td><b>class</b>̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>ini</td>
 *     <td>C</td>
 *     <td>l̒lw肵܂B</td>
 *   </tr>
 *   <tr>
 *     <td>attr</td>
 *     <td>C</td>
 *     <td>w肳ꂽl𑮐lƂĒǉ܂B</td>
 *   </tr>
 *   <tr>
 *     <td>nocnv</td>
 *     <td>C</td>
 *     <td>^O̕ϊsȂꍇAtrueݒ肵܂B</td>
 *   </tr>
 * </table>
 * <p>쌠: Copyright (c) 2002</p>
 * @author Hamanaka
 * @version 1.0
 */
public class TextArea extends TagSupport {

  private static final long serialVersionUID = -3013880849638321848L;
  private static final String[] TAGNMS =
  {"<textarea name=\"", " rows=\"", " cols=\"", " class=\""};

	private String _item = null;
	private String _rows = null;
	private String _cols = null;
	private String _read = null;
	private String _cls = null;
	private String _ini = "";
  private String _attr = "";
  private String _nocnv = null;

	/**
	 * ^OJnɌĂяo
	 *
	 * @return <code>EVAL_BODY_INCLUDE</code>
	 * @throws JspException
	 */
	public int doStartTag() throws JspException {
		//l̊mF
		if (_item == null) {
			return SKIP_BODY;
		} // end of if ()

    String[] dts = {_item, _rows, _cols, _cls};
    StringBuilder sb = new StringBuilder();
    for (int i=0; i < dts.length; i++) {
      if (dts[i] != null) {
        sb.append(TAGNMS[i]);
        sb.append(dts[i]);
        sb.append("\"");
        if (i == 0) {
          sb.append(" id=\"");
          sb.append(dts[i]);
          sb.append("\"");
        }
      }
    }
    if(_read != null) {
      sb.append("readonly ");
    }
    sb.append(_attr);
    sb.append(">");

    boolean ncnv = false;
    if (_nocnv != null && _nocnv.length() > 0) {
    	if (_nocnv.toUpperCase().startsWith("T") ||
    			_nocnv.toUpperCase().startsWith("Y")) ncnv = true;
    }
    String msg = MessageUtil.getItem(pageContext.getRequest(), _item, ncnv);
    if (msg == null || msg.length() == 0) {
      msg = _ini;
    }
    sb.append(msg);
    sb.append("</textarea>\n");
    sb.append(MessageUtil.createErrorMsg(pageContext.getRequest(), _item));

		try {
			pageContext.getOut().println(sb.toString());
		} catch (Exception ioe) {
			throw new JspException(ioe.getMessage());
		}
    release();
		return SKIP_BODY;
	}

	/**
	 * ^OIɌĂяo
	 *
	 * @return <code>EVAL_PAGE</code>
	 * @throws JspException
	 */
	public final int doEndTag() throws JspException {
		return EVAL_PAGE;
	}

	/**
	 * <CODE>item</CODE>̐ݒ
	 * @param item Value to assign to (String)item.
	 */
	public final void setItem(String item) {
		_item = item;
	}

	/**
	 * <CODE>rows</CODE>̐ݒ
	 * @param rows Value to assign to (String)classe.
	 */
	public final void setRows(String rows) {
		_rows = rows;
	}

	/**
	 * <CODE>cols</CODE>̐ݒ
	 * @param cols Value to assign to (String)cols.
	 */
	public final void setCols(String cols) {
		_cols = cols;
	}

	/**
	 * <CODE>read</CODE>̐ݒ
	 * @param read Value to set to readonly.
	 */
	public final void setRead(String read) {
		_read = read;
	}

	/**
	 * <CODE>cls</CODE>̐ݒ
	 * @param cls Value to assign to (String)cls.
	 */
	public final void setCls(String cls) {
		_cls = cls;
	}

	/**
	 * <CODE>ini</CODE>̐ݒ
	 * @param ini Value to assign to (String)initial value.
	 */
	public final void setIni(String ini) {
		_ini = ini;
	}

	/**
	 * ^O̓ԂZbg
	 */
	public void release() {
		_item = null;
		_rows = null;
		_cols = null;
		_read = null;
		_cls = null;
		_ini = "";
    _attr = "";
    _nocnv = null;
		super.release();
	}

  /**
   * @param argAttr attr ݒ肵܂B
   */
  public final void setAttr(String argAttr) {
    _attr = argAttr;
  }

	/**
	 * @param nocnv Zbg nocnv
	 */
	public void setNocnv(String nocnv) {
		_nocnv = nocnv;
	}

}
