package com.hamaf.hikyaku.ui;

import java.io.File;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;


/**
 * <p>^Cg:t@C_E[hProcessBaseNX.</p>
 * <p>:RequestőMꂽ_Et@CCommonMessageResponseɊi[</p>
 * <br>DowanLoadt@C̎w@
 * <ol>
 *   <li>pX̎w@
 *   <ul>
 *     <li>}X^XMLɃpXw肵^O[g̒ɐݒ肷B
 *     <li><code>(JSP)</code><b>PassTag</b>̖̂ł̃^O𑗐MB
 *   </ul>
 *   <li>t@CF<code>(JSP)</code><b>FileName</b>̖̂őMB
 * </ol>
 * <p>쌠: Copyright (c) 2004</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class FileDownLoad extends ProcessBase {

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    String passtag = msg.getReqStr("PassTag");
    String pass = msg.getReqStr("FilePass");
    String filenm = msg.getReqStr("FileName");
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    StringBuffer sb = new StringBuffer();
    sb.append(mxc.getConstant(passtag));
    sb.append(File.separator);
    if (pass.length() > 0) {
      sb.append(pass);
      sb.append(File.separator);
    }
    sb.append(filenm);

    msg.setResMsg("fileName", filenm);
    msg.setResMsg("internalFilePath", sb.toString());
    return msg;
  }
}
