package com.hamaf.hikyaku.ui;

import java.util.Set;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.extension.ItemChecks;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgF StandardCheckProcess W`FbN ProcessBase.</p>
 * <p>Fڃ`FbNsp̊gNXłB</p>
 * <br>ȉ̏Lq܂
 * <table border="1" >
 *   <tr bgcolor="#eeeeff">
 *     <td>b\h</td>
 *     <td>K{/C</td>
 *     <td>T</td>
 *   </tr>
 *   <tr>
 *     <td>setFolder</td>
 *     <td>C</td>
 *     <td>`FbNp̃tH_߂
 *        <br>DiContainarɂARXgN^[<b>_cfld</b>ɐݒ肵Ă܂܂B
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>checkMaster</td>
 *     <td>C</td>
 *     <td>}X^Ƃ̃`FbN</td>
 *   </tr>
 *   <tr>
 *     <td>checkRelation</td>
 *     <td>C</td>
 *     <td>ڊԊ֘A`FbN</td>
 *   </tr>
 *   <tr>
 *     <td>setEditItem</td>
 *     <td>C</td>
 *     <td>ҏWڂ̐ݒ菈</td>
 *   </tr>
 * </table>
 * <br>DiContainer𗘗pꍇARXgN^ňȉ̈ݒ\łB
 * <ul>
 *   <li>String (ڃ`FbNptH_) : _cfld ɐݒ肷
 * </ul>
 * 
 * <p>쌠: Copyright (c) 2007/05/29</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class StandardCheckProcess extends ProcessBase {
  
  /**
   * _cfld a <code>String</code> : ڃ`FbNp̃tH_[
   */
  protected String _cfld = null;

  /**
   * Describe <code>exec</code> method : `FbNs.
   * <ol>
   *   <li>ڃ`FbN<code>(ItemChecks)</code>ɂAڃ`FbNsB
   *      ̍ہA<b>setFolder()</b>tH_[擾B
   *   <li>L`FbNm[}ł΁A}X^`FbN<b>checkMaster()</b>sB
   *   <li>L`FbNm[}ł΁Aڊԃ`FbN<b>checkRelation()</b>sB
   *   <li>L`FbNm[}ł΁ANGXgڂX|XڂɕʂB
   *   <li>ڕҏW<b>setEditItem()</b>ĂяoB
   * </ol>
   * @param commonMessage a <code>CommonMessage</code> : 
   * @return a <code>CommonMessage</code> : 
   * @exception Exception if an error occurs
   */
  public final CommonMessage exec(CommonMessage msg) throws Exception {
    msg.setErrorStatus(STATUS.NORMAL);

    if (_cfld == null) {
      _cfld = setFolder();
    }
    if (_cfld != null && _cfld.length() > 0) {
      ItemChecks itc = new ItemChecks();
      msg = itc.check(msg, _cfld);
      if (msg.getErrorStatus() != STATUS.NORMAL) {
        return msg;
      }
    }

    msg = checkMaster(msg);
    if (msg.getErrorStatus() != STATUS.NORMAL) {
      return msg;
    }
    
    msg = checkRelation(msg);
    if (msg.getErrorStatus() != STATUS.NORMAL) {
      return msg;
    }
    
    msg = copyReq2Res(msg);
    return setEditItem(msg);
  }

  /**
   * Describe <code>copyReq2Res</code> method : NGXgڂ̕.
   * <br><code>CommonMessage</code>RequestڂResponceڂɕʂB
   * @param msg a <code>CommonMessage</code>
   * @return a <code>CommonMessage</code>
   */
  private CommonMessage copyReq2Res(CommonMessage msg) {
    Set<String> ks = msg.getReqKeys();
    for (String kval : ks) {
      msg.setResMsg(kval, msg.getReq(kval));
    }
    return msg;
  }

  /**
   * Describe <code>setFolder</code> method : `FbNp̃tH_[߂.
   * <br>iDiContainaergpRXgN^[Őݒ肷ꍇ́AsvłBj
   * <br>W̍ڃ`FbNsꍇɁA`FbN`ĂtH_[߂܂B
   * <br>{Iɂ́A
   * <br> <code>return "tH_[";</code>
   * <br>Lq܂B
   * @return a <code>String</code> : `FbN`ĂtH_[
   */
  protected String setFolder() {
    return null;
  }
  /**
   * Describe <code>checkMaster</code> method : }X^`FbN.
   * <br>}X^Ȃǂɂ`FbNsꍇɁA<b>Override</b>܂B
   * @param msg a <code>CommonMessage</code> : 
   * @return a <code>CommonMessage</code> : 
   * @exception Exception if an error occurs
   */
  protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
    return msg;
  }
  /**
   * Describe <code>checkRelation</code> method : ֘A`FbN.
   * <br>ڊԂ̊֘A`FbNKvȏꍇɁA<b>Override</b>܂B
   * @param msg a <code>CommonMessage</code> : 
   * @return a <code>CommonMessage</code> : 
   * @exception Exception if an error occurs
   */
  protected CommonMessage checkRelation(CommonMessage msg) throws Exception {
    return msg;
  }
  /**
   * Describe <code>setEditItem</code> method : ҏWڐݒ菈.
   * <br>\ڂҏWĐݒ肷ꍇɁA<b>Override</b>܂B
   * @param msg a <code>CommonMessage</code> : 
   * @return a <code>CommonMessage</code> : 
   * @exception Exception if an error occurs
   */
  protected CommonMessage setEditItem(CommonMessage msg) throws Exception {
    return msg;
  }
  
}
