package com.hamaf.hikyaku.ui;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.JspItemsMapping;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;


/**
 * <p>^CgF StandardDetailProcess Wڍו\ ProcessBase.</p>
 * <p>Fڍ׍ڕ\p<b>ProcessBase</b>gNXB</p>
 * <br>ȉ̏Lq܂
 * <table border="1">
 *   <tr bgcolor="#eeeeff">
 *     <td>b\h</td>
 *     <td>K{/C</td>
 *     <td>T</td>
 *   </tr>
 *   <tr>
 *     <td>newDataObj</td>
 *     <td>K{</td>
 *     <td>ڍ׎擾p<b>DetaObejct</b>𐶐Ė߂</td>
 *   </tr>
 *   <tr>
 *     <td>callControl</td>
 *     <td>K{</td>
 *     <td>Rg[̌Ăяos</td>
 *   </tr>
 *   <tr>
 *     <td>setJspMapping</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕RtNXo^
 *        <br>DiContainarɂARXgN^[<b>_jim</b>ɐݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setItems</td>
 *     <td>C</td>
 *     <td><b>DetaObject</b>̍ڔԍJSP̍ږ̂̕Rto^
 *        <br>LA<b>setJspMapping</b>Őݒ肷ꍇ͕svłB
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setKeys</td>
 *     <td>C</td>
 *     <td>
 *       <b>DetaObejct</b><b>CommonMessage</b>PrimaryKeylݒ肷
 *       ̃\bh̖߂l<code>true</code>w肵܂B
 *     </td>
 *   </tr>
 *   <tr>
 *     <td>setPrimaryValue</td>
 *     <td>C</td>
 *     <td><b>DetaObejct</b><b>KeyList</b>keyl(List)PrimaryKeylݒ肷</td>
 *   </tr>
 *   <tr>
 *     <td>editItems</td>
 *     <td>C</td>
 *     <td>ҏWsڂX|Ẍɐݒ肷</td>
 *   </tr>
 * </table>
 * <br>DiContainer𗘗pꍇARXgN^ňȉ̈ݒ\łB
 * <ul>
 *   <li>JspItemsMapping : _jim ɐݒ肷
 * </ul>
 *
 * <p>Created: Mon Feb 21 13:39:36 2005</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class StandardDetailProcess extends ProcessBase {

  /**
   * _jim a <code>JspItemsMapping</code> : JSPږ́Ff[^IuWFNgڑΉNX
   */
  protected JspItemsMapping _jim= null;

  /**
   * Describe <code>exec</code> method : ڍו\p̍ڎ擾s.
   * <ol>
   *   <li><b>setItems()</b>ĂяoA_items<code>(Map)</code>ݒ肷B
   *   <li><b>setGetKey()</b>AL[ݒ肳Ă<code>DataObject</code>擾B
   *   <li>DataObjectɎ擾ڂ_itemݒ肷B
   *   <li><b>callControl()</b>ɂăRg[NX̌ĂяosB
   *   <li>DataObject̓eX|Ẍɐݒ肷B
   *   <li>ҏWڂ̐ݒ菈<b>editItems</b>ĂяoB
   * </ol>
   *
   * @param commonMessage a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  public final CommonMessage exec(CommonMessage msg) throws Exception {
    if (_jim == null) {
      _jim = setJspMapping();
      if (_jim == null) {
        _jim = new JspItemsMapping();
        setItems();
      }
    }

    DetailItemsInterface dii = newDataObj();
    if (!setKeys(dii, msg)) {
      setKey4KeyList(msg, dii);
    }
    setRequest2DTO(dii);
    dii.setSysId(sysId);
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      dii.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    dii = callControl(dii);

    msg = setMessageFromDTO(msg, dii);
    return editItems(msg);
  }

  /**
   * Describe <code>newDataObj</code> method : ڍחpDataObject̐.
   * <br>ڍ׃f[^擾pDataObject𐶐B
   * <br>{Iɂ́A
   * <br> return new _DetailDTO_();
   * <br>ƂȂ܂B
   * @return a <code>DetailItemsInterface</code> : DataObject
   */
  protected abstract DetailItemsInterface newDataObj();

  /**
   * Describe <code>setGetKey</code> method : PrimaryKeyڂ̒lKeyListݒ肷.
   * <br>NGXgڂ<b>'pos'</b>̒l<code>KeyList</code>A
   * PrimaryKey̒lݒ肷B
   * @param msg a <code>CommonMessage</code>
   * @param dii a <code>DetailItemsInterface</code> :
   */
  private void setKey4KeyList(CommonMessage msg, DetailItemsInterface dii) {
    if (super.saveObj == null) {
      super.log.fine("primaryKey not set : saveObj is null");
      return;
    }
    String spos = msg.getReq("pos");
    if (spos == null || spos.length() == 0) {
      super.log.fine("primaryKey not set : 'pos' not in request");
      return;
    }

    KeyList kyl = (KeyList)super.saveObj;
    int ps = Integer.parseInt(spos);
    setPrimaryValue(dii, kyl.getKey(ps), kyl.getKeyFields());
  }

  /**
   * Describe <code>setRequest2DTO</code> method : Request item ̐ݒ.
   * <br>f[^IuWFNgɎ擾ڂ_jimݒ肷B
   * @param dii a <code>DetailItemsInterface</code> :
   */
  private void setRequest2DTO(DetailItemsInterface dii) {
    for (String fld : _jim) {
      dii.setRequestItem(_jim.getDtoNo(fld));
    }
  }

  /**
   * Describe <code>setMessageFromDTO</code> method : \pڂ̐ݒ.
   * <br>擾f[^<code>_items(Map)</code>ɏ]āAf[^IuWFNg烌X|Ẍɐݒ肷B
   * @param msg a <code>CommonMessage</code>
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>CommonMessage</code>
   */
  private CommonMessage setMessageFromDTO(CommonMessage msg, DetailItemsInterface dii) {
    for (String fld : _jim) {
      msg.setResMsg(fld, dii.getItemValue(_jim.getDtoNo(fld)));
    }

    for (COMMFLD fld : COMMFLD.values()) {
      msg.setResMsg(fld.getVal(), dii.getCommFld(fld));
    }

    return msg;
  }

  /**
   * Describe <code>addItem</code> method : 擾ڔԍ:\ږ̗pMapւ̓o^.
   * <br>_items(<code>Map</code>)ɍڔԍJSPł̍ږ̕Rto^B
   * <ol>
   *  <li>key : JSPŎw肳Ă鍀ڂ̖(<code>String</code>)
   *  <li>value : DetailItemsInterfaceNX̍ڔԍ
   * </ol>
   * @param jspnm a <code>String</code> : JSPł̍ږ
   * @param pos an <code>int</code> : f[^ObjectŒ`Ă鍀ڈʒu
   */
  protected final void addItem(String jspnm, int pos) {
    _jim.addItem(jspnm, pos);
  }

  /**
   * Describe <code>setJspMapping</code> method : JSP}bsO̐ݒs.
   * <br>iDiContainaergpRXgN^[Őݒ肷ꍇ́AsvłBj
   * <br>JspItemsMappinǧpNXCX^XA߂B
   * <br>return new xxxMapping();
   */
  protected JspItemsMapping setJspMapping() {
    return null;
  }

  /**
   * Describe <code>setItems</code> method : ڂ̓o^.
   * <br>iJspItemsMapping̊gNXgpꍇ́AsetJspMapping𗘗p܂j
   * <br>鍀ڂ<b>DeataObject</b>̒`l(<code>int</code>)JSPł̖̂Ƃ
   *  Rto^B
   * <br>{Iɂ
   * <br> addItem(DataObject.ITEM_NAME, "JSPł̍ږ");
   * <br>ɂĕKvڕARto^sB
   */
  protected void setItems() { }

  /**
   * Describe <code>callControl</code> method : Rg[NXĂяo.
   * <br>Rg[NXĂяoA߂lDetaObject߂B
   * <ol>
   *   <li> _Process_Control xcntl = new _Process_Control();
   *   <li> return xcntl.getDetail(dii);
   * </ol>
   * @param dii a <code>DetailItemsInterface</code> :
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>DetailItemsInterface</code> :
   * @exception Exception if an error occurs
   */
  protected abstract DetailItemsInterface callControl(DetailItemsInterface dii)
     throws Exception;

  /**
   * Describe <code>setKeys</code> method : DataObjectKeyڂbZ[Wݒ肷.
   * <br><b>CommonMessage</b>̓eɂA擾f[^PrimaryKeylݒ肷B
   * <br>ݒ肵ꍇ́A<b>true</b>߂lƂĖ߂B
   * <br><code>KeyList</code>ł͂ȂANGXg̍ڂ擾f[^<b>PrimaryKey</b>lݒ肷ꍇɁÃb\hI[o[Ch܂B
   *
   * @param dii a <code>DetailItemsInterface</code> :
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>boolean</code> : <b>true</b>߂B
   */
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    return false;
  }

  /**
   * Describe <code>setPrimaryValue</code> method : DetaObjectPrimaryKeylݒ肷.
   * <br><b>KeyList Object</b>ɕۑĂl<b>DetaObejct</b>Keyڂ֐ݒ肷
   * <br><code>DetaObject</code>PrimaryKeyڂ0Ԗڂ菇Ԃɒ`A
   * <br><code>KeyList</code>ɕۑĂKeyPrimaryKeyڂ̏ꍇɂ́A
   * <br>̂܂܎gpł܂B
   * <br>LȊȌꍇɂ́A<b>override</b>āAKeyl̐ݒs܂B
   * <br>PrimariKeyڂP̏ꍇ́A
   * <ol>
   *   <li>dii.setItemValue(_DataObject_.KEY_ITEM, (String)key.get(0));
   * </ol>
   * ƂȂ܂B
   * @param dii a <code>DetailItemsInterface</code> :
   * @param key a <code>List&lt;String&gt;</code> : KeyList̊YʒũIuWFNg
   * @param keyFld a <code>List&lt;String&gt;</code> : L[ږ̂̃Xg
   */
  protected void setPrimaryValue(DetailItemsInterface dii, List<String> key, List<String> keyFld) {
    for (int i = 0; i < key.size(); i++) {
      dii.setFldValue(keyFld.get(i), key.get(i));
    }
  }

  /**
   * Describe <code>editItems</code> method : ڕҏW.
   * <br>ҏWĕ\鍀ڂX|Ẍɐݒ肷ꍇA<b>override</b>B
   * @param msg a <code>CommonMessage</code> :
   * @return a <code>CommonMessage</code> :
   * @exception Exception if an error occurs
   */
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    return msg;
  }
}
