package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquyDto;
import com.hamaf.hikyakucms.sample.sns.process.SoliloquyProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.SoliloquyMap;

/**
 * <p>^CgFSoliloquyUpdate is .</p>
 * <p>FƂ茾̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/30</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class SoliloquyUpdate extends StandardUpdateProcess {

  private SoliloquyProcess _sp = null;
  /**
   * Creates a new <code>SoliloquyUpdate.java</code> instance.
   * <br>Default Constructor
   */
  public SoliloquyUpdate() {
    _jim = new SoliloquyMap();
    _sp = new SoliloquyProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new SoliloquyDto();
  }

  private final String MSG_OK = "SoliloquyUpdate";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _sp.regist((SoliloquyDto)dii);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
