﻿package com.hamaf.hikyakucms.sample.wiki.access;

import com.hamaf.hikyaku.access.DefaultTableAccess;

/**
 * <p>タイトル：WikiArticleAccess is .</p>
 * <p>説明：M_WIKIARTICLE(Wiki記述管理)アクセス用クラス</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/06</p>
 * @author @USR
 * @version 1.0
 */
public class WikiArticleAccess extends DefaultTableAccess {

  private final String TBLNM = "M_WIKIARTICLE";
  private final String PARM = "hsmpl";

  /**
   *  Creates a new <code>WikiArticleAccess.java</code> instance.
   * <br>Default Constructor
   */
  public WikiArticleAccess() {
    tableName = TBLNM;
    connectionParameter = PARM;
//    super.setDebug();
  }

}
