package com.hamaf.hikyakucms.sample.wiki.ui;

import java.io.File;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.MultiCommonMessage;
import com.hamaf.hikyaku.distribute.ServletUtils;
import com.hamaf.hikyaku.ui.MultipartProcessBase;

/**
 * <p>^CgFAppendAdd is .</p>
 * <p>Ft@C̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AppendAdd extends MultipartProcessBase {

  private final String MSG_REP = "overwrite";
  private final String WER_MSG_B = "t@C(";
  private final String WER_MSG_A = ")݂̂œo^ł܂łB";
  private final String IMG_PATH = "plugins/wiki/img/";
  private final String FILE_URL = "furl";
  private final String MSG_OK = "FileAdd";
  /**
   * Creates a new <code>AppendAdd.java</code> instance.
   * <br>Default Constructor
   */
  public AppendAdd() {
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MultiCommonMessage mcm = (MultiCommonMessage)msg;
    String fnm = mcm.getFileName().replaceAll("\\\\", "/");
    int p = fnm.lastIndexOf("/");
    if (p > 0) fnm = fnm.substring(p);
    StringBuilder real = new StringBuilder();
    real.append(ServletUtils.whichFile("/").replaceAll("\\\\", "/"));
    real.append(IMG_PATH);
    real.append(fnm);
    File rfile = new File(real.toString());
    if (rfile.exists()) {
      String chk = mcm.getReqStr(MSG_REP);
      if (!"1".equals(chk)) {
        StringBuilder sb2 = new StringBuilder();
        sb2.append(WER_MSG_B);
        sb2.append(fnm);
        sb2.append(WER_MSG_A);
        mcm.addMessage(sb2.toString());
        mcm.setResMsg(MSG_OK, "0");
        return mcm;
      }
    }
    File org = new File(mcm.getTempFileUrl());
    org.renameTo(rfile);
    
    StringBuffer surl = request.getRequestURL();
    surl.setLength(surl.length() - 1);
    p = surl.lastIndexOf("/");
    surl.setLength(p + 1);
    surl.append(IMG_PATH);
    surl.append(fnm);
    mcm.setResMsg(FILE_URL, surl.toString());
    
    mcm.setResMsg(MSG_OK, "1");
    return mcm;
  }

}
