/**
 *
 */
package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.wiki.util.WikiDocument;

/**
 * <p>^CgFWikiPreview is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiPreview extends ProcessBase {

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    WikiDocument wd = new WikiDocument();
    if ("0".equals(msg.getReqStr(WikiDetail.CHAPTER))) {
      wd.setHeader(msg.getReqStr("title"),
      msg.getReqStr("category"), msg.getReqStr("sammary"));
      String name = "";
      Object udt = session.getAttribute(LogInCheck.USER_INF);
      if (udt != null && udt instanceof UserDto) {
        name = ((UserDto)udt).getItemValue(UserDto.NAME);
      }
      wd.setCreate(name, DateUtil.getDate(), DateUtil.getTime());
      wd.setLast("", "", "");
    }
    wd.setDocument(msg.getReqStr(WikiDetail.CONTENTS), 
        msg.getReqStr(WikiDetail.CHAPTER), msg.getReqStr(WikiDetail.SECTION));
    if ("0".equals(msg.getReqStr(WikiDetail.CHAPTER))) {
      msg.setResMsg(WikiDetail.HTML, wd.getHtml(true, false));
    } else {
      msg.setResMsg(WikiDetail.HTML, wd.getDoc().getHtmlAll(true));
    }
    return msg;
  }

}
