package com.hamaf.hikyaku.extension;

import java.util.List;
import java.util.Map;

/**
 * <p>^CgFMasterXmlControl is Maste Data Xml File Controler interface.</p>
 * <p>F}X^pXmlFilȇsB</p>
 * <br>XMĽ`Ȉȉ̃^O\Ƃ邱
 * <pre>
 *   <_roottag_>
 *     <_const_>...</_const_>
 *     <_const2_>...</_const2_>
 *       E
 *       E
 *     <_item_s>
 *       <_item_>
 *         <_item_Code>...</_item_Code>
 *         <_item_Name>...</_item_Name>
 *         <_Cӂ̃^O_>...</_Cӂ̃^O_>
 * @@@@@@@@E
 * @@@@@@@@E
 *       </_item_>
 *       <_item_>
 *            E
 *            E
 *       </_item_>
 *     </_item_s>
 *     <_item2_s>
 *          E
 *          E
 *     </_item2_s>
 *   </_roottag_>
 *   j_t̖͎̂RɎwł܂B
 * </pre>
 * <br>T|[gĂ郁\bh
 * <ul>
 *   <li>getConstant(String constTag) : &lt;_constTag_&gt;̒l߂B</li>
 *   <li>getItemsList(String item) : &lt;_item_&gt;ȉCode,Name ^O̒lStringzɂA
 *       List Objectɐݒ肵Ė߂B</li>
 *   <li>getItemValue(String item, String code) : &lt;_item_&gt;Codel<b>code</b>
 *       &lt;_item_s&gt;̔z̊e^Ô̖KeyƂĒlValueƂMap Object߂B</li>
 * </ul>
 * <br>ǂݍXML File͔rt@CɃ^O&lt;MasterXml&gt;Ŏw肳ꂽ̂gpB
 * 
 * <p>쌠: Copyright (c) 2004/08/25</p>
 * @author y-hamanaka
 * @version 1.0
 */
public interface MasterXmlControl {
  /**
   * Describe <code>getConstant</code> method : return child tag value.
   * <br>[g^O̒ɂw肳ꂽ^O̒l߂B
   * @param constTag a <code>String</code> : l擾^O
   * @return a <code>String</code> : Y^O̒l
   * @exception IllegalStateException : }X^XMLێĂȂꍇ
   * @exception IllegalArgumentException if an error occurs
   */
  public abstract String getConstant(String constTag)
    throws IllegalStateException, IllegalArgumentException;
  /**
   * Describe <code>getItemsList</code> method : return item code,name list.
   * <br>w肳ꂽItem^OɊ܂܂ĂR[hƖ̂StringzListɂĖ߂B
   * @param item a <code>String</code> : 擾e^O
   * @return a <code>List</code> : Code,NameZbgꂽXg
   * @exception IllegalStateException : }X^XMLێĂȂꍇ
   * @exception IllegalArgumentException if an error occurs
   */
  public abstract List<String[]> getItemsList(String item)
    throws IllegalStateException, IllegalArgumentException;
  /**
   * Describe <code>getItemValue</code> method : return select tag,value Map.
   * <br>w肵^OŃR[hlvCOdeTagƓꃌxɂtaĝ̖ƒlMap߂B
   * @param item a <code>String</code> : 擾^O
   * @param code a <code>String</code> : Yf[^̃R[hl
   * @return a <code>Map</code> : ^ÔƒlMAP
   * @exception IllegalStateException : }X^XMLێĂȂꍇ
   * @exception IllegalArgumentException if an error occurs
   */
  public abstract Map<String, String> getItemValue(String item, String code)
    throws IllegalStateException, IllegalArgumentException;
  
  /**
   * Describe <code>getTagValue</code> method : return tag value.
   * <br>w肵ItemcodelvCodeTagƓꃌxɂtag̒l߂B
   * 
   * @param item a <code>String</code> : 擾Item̖
   * @param code a <code>String</code> : Yf[^̃R[hl
   * @param tag a <code>String</code> : l擾Tag
   * @return a <code>String</code> : 擾l
   */
  public abstract String getTagValue(String item, String code, String tag);
    
}