package com.hamaf.hikyaku.extension;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>^CgFMasterXmlFactory is save MasterXmlCntlImpl Object.</p>
 * <p>F}X^XMLNXێFactoryNXłB</p>
 * <br>}`TCgpɃVXe̖ɕێ܂B
 * 
 * <p>쌠: Copyright (c) 2004/08/24</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class MasterXmlFactory {
  
  private static MasterXmlFactory myObj = new MasterXmlFactory();
  private Map<String, MasterXmlControl> mstxml = new HashMap<String, MasterXmlControl>();

  /**
   *  Creates a new <code>MasterXmlFactory.java</code> instance.
   * <br>Default Constructor
   * 
   */
  private MasterXmlFactory() {
  }
  
  public static MasterXmlFactory newInstance() {
    return myObj;
  }
  
  /**
   * Describe <code>getMasterXml</code> method : return MasterXmlControl.
   * <br>VXêŎw肳ꂽ<code>MasterXmlControl</code>߂B
   * <br>wlk󂯎ȂA2ڈȍ~ŗLȃ\bh
   * @param sysName a <code>String</code> : vOC
   * @return a <code>MasterXmlControl</code>
   */
  public final MasterXmlControl getMasterXml(String sysName) {
    MasterXmlControl mxc = mstxml.get(sysName);
    if (mxc instanceof MasterXmlControl) {
      return mxc;
    }
    mxc = new MasterXmlCntlImpl(sysName);
    mstxml.put(sysName, mxc);
    return (MasterXmlControl)mxc;
  }
  
  /**
   * Describe <code>resetMaster</code> method : reset MasterXmlControl.
   * <br>w肳ꂽVXeID<code>MasterXmlControl</code>Đݒ肷B
   * 
   * @param pluginId a <code>String</code> : vOCID
   */
  public final void resetMaster(String pluginId) {
    MasterXmlControl mxc = new MasterXmlCntlImpl(pluginId);
    mstxml.put(pluginId, mxc);
  }

}
