package com.hamaf.hikyaku.extension;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * <p>^CgF Recoder is ĂяoȂǂL^.</p>
 * <p>FClass, Method ̌ĂяoȂǂL^IuWFNgB</p>
 * <br>SingletonŎAȉ̃\bhpӂĂ
 * <ol>
 *   <li> record() : ĂяoƂ<code>Class, Method</code>ۑ
 *   <li> playBack() : ۑĂ߂
 *   <li> clear() : ۑĂ
 * </ol>
 *
 *
 * <p>Created: Thu Apr 14 11:48:38 2005</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class Recoder {
  private static final Recoder _MyObj = new Recoder();

  private static final String DEF_ID = "DUMMYSYS";
  private Map<String, List<String>> _recMap = new HashMap<String, List<String>>();

  private Recoder() {
  }
  public static Recoder getInstance() {
    return _MyObj;
  }

  public void record(String id, String msg) {
    if (id == null) {
      id = DEF_ID;
    }
    List<String> rec = _recMap.get(id);
    if (rec == null) {
      rec = new LinkedList<String>();
    }
    StringBuilder sb = new StringBuilder(getClsMtd());
    if (msg != null && msg.length() > 0) {
      sb.append(" Message('");
      sb.append(msg);
      sb.append("').");
    }
    rec.add(sb.toString());
    _recMap.put(id, rec);
  }
  private String getClsMtd() {
    Throwable thr = new Throwable();
    StackTraceElement[] stes = thr.getStackTrace();
    StringBuilder sb = new StringBuilder();
    sb.append("Class('");
    sb.append(stes[2].getClassName());
    sb.append("'), Method('");
    sb.append(stes[2].getMethodName());
    sb.append("') ;");
    return sb.toString();
  }

  public void clear(String id) {
    if (id == null) {
      id = DEF_ID;
    }
    _recMap.remove(id);
  }

  public String playBack(String id) {
    if (id == null) {
      id = DEF_ID;
    }
    List<String> ret = playBackList(id);
    if (ret == null) {
      return "";
    }
    StringBuilder sb = new StringBuilder();
    for (String dt : ret) {
      sb.append(dt);
      sb.append("\n");
    }
    return sb.toString();
  }

  public List<String> playBackList(String id) {
    if (id == null) {
      id = DEF_ID;
    }
    return _recMap.get(id);
  }

  public String toString() {
    return _recMap.toString();
  }
}