package com.hamaf.hikyaku.plugIn.process;

import com.hamaf.hikyaku.plugIn.access.PluginAccess;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.dto.PluginSearchDto;

/**
 * <p>^CgFPluginInfoAcquisition.</p>
 * <p>FvOCEe[u擾B</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/03</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PluginInfoAcquisition {

  private PluginAccess _pa = null;

  /**
   *  Creates a new <code>PluginInfoAcquisition.java</code> instance.
   * <br>Default Constructor
   */
  public PluginInfoAcquisition(PluginAccess pa) {
    _pa = pa;
  }
  
  /**
   * Describe <code>find</code> method : search M_PLUGIN.
   * <br>vOCDB̌sB
   * 
   * @param psd a <code>PluginSearchDto</code> : 
   * @return a <code>PluginSearchDto</code> : 
   * @throws Exception
   */
  public PluginSearchDto find(PluginSearchDto psd) throws Exception {
    return (PluginSearchDto)_pa.find(psd);
  }
  
  /**
   * Describe <code>findByPrimary</code> method : get M_PLUGIN.
   * <br>vC}[L[ŃvOCDB擾B
   * 
   * @param pid a <code>PluginInfDto</code> : 
   * @return a <code>PluginInfDto</code> : 
   * @throws Exception
   */
  public PluginInfDto findByPrimary(PluginInfDto pid) throws Exception {
    return (PluginInfDto)_pa.findByPrimaryKey(pid);
  }
  
  /**
   * Describe <code>updateMenuSeq</code> method : update menu_seq at M_PLUGIN.
   * <br>vOCe[uMENU_SEQXVB
   * <br>r͍s܂B
   * 
   * @param plgId a <code>String</code> : vOCID
   * @param seq an <code>int</code> : j[\ 
   * @throws Exception
   */
  public void updateMenuSeq(String plgId, int seq) throws Exception {
  	PluginInfDto pid = new PluginInfDto();
  	pid.setItemValue(PluginInfDto.PLUGIN_ID, plgId);
  	pid.setItemValue(PluginInfDto.MENU_SEQ, String.valueOf(seq));
  	_pa.updateNoExclusion(pid);
  }

}
