package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.plugIn.dto.InitDto;
import com.hamaf.hikyaku.plugIn.process.InitInfAcquisition;
import com.hamaf.hikyaku.plugIn.ui.mapping.InitInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFInitMod is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/23</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class InitMod extends StandardCheckAndUpdate {

  private InitInfAcquisition _iia = null;
  /**
   *  Creates a new <code>InitMod.java</code> instance.
   * <br>Default Constructor
   */
  public InitMod(InitInfMap iim, InitInfAcquisition iia) {
    _jim = iim;
    _iia = iia;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#setFolder()
   */
  @Override
  protected String setFolder() {
    return "InitMod";
  }

  private final String MODOK = "InitMod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _iia.update((InitDto)dii);
    msg.setResMsg(MODOK, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new InitDto();
  }

}
