package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.PossibleDto;
import com.hamaf.hikyaku.security.process.PossibleProcess;
import com.hamaf.hikyaku.security.ui.mapping.PossibleInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFPossibleMod is .</p>
 * <p>F̍XV</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PossibleMod extends StandardCheckAndUpdate {

  private PossibleProcess _pp = null;
  
  /**
   *  Creates a new <code>PossibleMod.java</code> instance.
   * <br>Default Constructor
   * @param pp
   * @param jim
   */
  public PossibleMod(PossibleProcess pp, PossibleInfMap jim) {
    _pp = pp;
    _jim = jim;
  }

  private final String MODOK = "PossibleMod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _pp.modify((PossibleDto)dii);
    msg.setResMsg(MODOK, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new PossibleDto();
  }

}
