package com.hamaf.hikyaku.security.ui;

import java.io.File;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.MultiCommonMessage;
import com.hamaf.hikyaku.distribute.ServletUtils;
import com.hamaf.hikyaku.ui.MultipartProcessBase;

/**
 * <p>^CgFUserIconMod is .</p>
 * <p>F[U[Iconݒ菈</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/17</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class UserIconMod extends MultipartProcessBase {

  public static final String ICON_PATH = "control/usericon/";

  private final String MSG_ICON = "iconPath";
  private final String MSG_TYPE = "iconType";
  private final String MSG_OK = "UserIconMod";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MultiCommonMessage mcm = (MultiCommonMessage)msg;
    String fnm = mcm.getFileName();
    String typ = "";
    int p = fnm.lastIndexOf(".");
    if (p > 0 && fnm.length() > p) typ = fnm.substring(p);
    StringBuilder sb = new StringBuilder();
    sb.append(ServletUtils.whichFile(ICON_PATH));
    sb.append("/");
    sb.append(getUserID());
    sb.append(typ);

    File tmp = new File(mcm.getTempFileUrl());
    File dest = new File(sb.toString());
    if (dest.exists()) dest.delete();
    tmp.renameTo(dest);

    StringBuilder sb2 = new StringBuilder();
    sb2.append(ICON_PATH);
    sb2.append(getUserID());
    sb2.append(typ);
    if (typ.length() > 0) typ = typ.substring(1);
    msg.setResMsg(MSG_ICON, sb2.toString());
    msg.setResMsg(MSG_TYPE, typ);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
