package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFUserSelfModIni.</p>
 * <p>F[U[gł̏ύXp\</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/04/27</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserSelfModIni extends StandardDetailProcess {

  /**
   *  Creates a new <code>UserSelfModIni.java</code> instance.
   * <br>Default Constructor
   */
  public UserSelfModIni(UserInfMap uim) {
    _jim = uim;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return (UserDto)session.getAttribute(LogInCheck.USER_INF);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#setKeys(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    return true;
  }

  
}
