package com.hamaf.hikyakucms.sample.sns.managerUi;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardDetailProcess;
import com.hamaf.hikyakucms.sample.sns.dto.VCommunicationDto;
import com.hamaf.hikyakucms.sample.sns.process.CommunicationProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.VCommunicationMap;

/**
 * <p>^CgFCommunicationDetail is .</p>
 * <p>FǗҗpڍ׉ʕ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommunicationDetail extends StandardDetailProcess {

  private CommunicationProcess _cp = null;

  /**
   * Creates a new <code>CommunicationDetail.java</code> instance.
   * <br>Default Constructor
   */
  public CommunicationDetail() {
    _jim = new VCommunicationMap();
    _cp = new CommunicationProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VCommunicationDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii) throws Exception {
    return _cp.getDetail((VCommunicationDto)dii);
  }

}
