package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.NoticeDto;
import com.hamaf.hikyakucms.sample.sns.process.NoticeProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.NoticeMap;

/**
 * <p>^CgFNoticeDelete is .</p>
 * <p>FǗҗpm点폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NoticeDelete extends StandardUpdateProcess {

  private NoticeProcess _np = null;

  /**
   * Creates a new <code>NoticeDelete.java</code> instance.
   * <br>Default Constructor
   */
  public NoticeDelete() {
    _jim = new NoticeMap();
    _np = new NoticeProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new NoticeDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (!"all".equals(msg.getReqStr("delType"))) {
      _np.del((NoticeDto)dii);
      return msg;
    }
    KeyList kyl = (KeyList)super.saveObj;
    for (List<String> keys : kyl) {
      for (int i = 0; i < keys.size(); i++) {
        dii.setItemValue(i, keys.get(i));
      }
      _np.del((NoticeDto)dii);
    }
    return msg;
  }

}
