package com.hamaf.hikyakucms.sample.sns.ui;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFBoardList is .</p>
 * <p>F\Ώیf̎擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/29</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BoardList extends ProcessBase {

  public static final String MSG_ID = "gid";
  public static final String MSG_GIDS = "groupIds";
  public static final String ALL_ID = "alusr";

  private SecurityCheckUtils _scu = null;
  /**
   * Creates a new <code>BoardList.java</code> instance.
   * <br>Default Constructor
   */
  public BoardList() {
    _scu = new SecurityCheckUtils();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    Map<String, String> alldt = new HashMap<String, String>();
    alldt.put(MSG_ID, ALL_ID);
    msg.addResList(alldt);
    StringBuilder sb = new StringBuilder();
    sb.append(ALL_ID);
    sb.append("\t");
    List<String> gid = _scu.getGroupByUser(getUserID());
    for (String grp : gid) {
      Map<String, String> dt = new HashMap<String, String>();
      dt.put(MSG_ID, grp);
      msg.addResList(dt);
      sb.append(grp);
      sb.append("\t");
    }
    sb.setLength(sb.length() - 1);
    msg.setResMsg(MSG_GIDS, sb.toString());
    return msg;
  }

}
