package com.hamaf.hikyakucms.sample.sns.ui;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;

/**
 * <p>^CgFNotAnswerList is .</p>
 * <p>FAP[g̖񓚎҈ꗗ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NotAnswerList extends ProcessBase {

  private AnswerProcess _ap = null;

  /**
   * Creates a new <code>NotAnswerList.java</code> instance.
   * <br>Default Constructor
   */
  public NotAnswerList() {
    _ap = new AnswerProcess();
  }

  private String MSG_UID = "userIds";
  private String MSG_UNM = "UserNames";
  private String MSG_CNT = "counter";
  private String DSP_CNT = "(Ώێ: {0}l)";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    String seqNo = msg.getReqStr("seqNo");
    String allfg = msg.getReqStr("allFlg");
    String grps = msg.getReqStr(CommunicationDetail.MSG_GID);
    List<String> grpl = new ArrayList<String>();
    if (grps.length() > 0 && !"1".equals(allfg)) {
      String[] grp = grps.split(",");
      for (int i = 0; i < grp.length; i++) {
        if (!getUserID().equals(grp[i])) grpl.add(grp[i]);
      }
    }
    StringBuilder uid = new StringBuilder();
    StringBuilder unm = new StringBuilder();
    List<String[]> usrs = _ap.getNotAnsUser(seqNo, grpl, sysId, getUserID());
    for (String[] udt : usrs) {
      Map<String, String> dt = new HashMap<String, String>();
      dt.put("userName", udt[0]);
      dt.put("userId", udt[1]);
      msg.addResList(dt);
      uid.append(udt[1]);
      uid.append(",");
      unm.append(udt[0]);
      unm.append(",");
    }
    if (uid.length() > 0) {
      uid.setLength(uid.length() - 1);
      unm.setLength(unm.length() - 1);
    }
    msg.setResMsg(MSG_UID, uid.toString());
    msg.setResMsg(MSG_UNM, unm.toString());
    List<String> arg = new ArrayList<String>();
    arg.add(Integer.toString(usrs.size()));
    msg.setResMsg(MSG_CNT, MessageFormat.format(DSP_CNT, arg));
    return msg;
  }

}
