﻿package com.hamaf.hikyakucms.sample.wiki.dto;

import com.hamaf.hikyaku.dataobject.RetrieveKeysBase;

/**
 * <p>タイトル：WikiDiffSearchDto is .</p>
 * <p>説明：M_WIKIDIFF(Wiki差分管理)の検索用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/10</p>
 * @author @USR
 * @version 1.0
 */
public class WikiDiffSearchDto extends RetrieveKeysBase {

  public static final int WIKI_NO = 0;
  public static final int DIFF_NO = 1;
  public static final int DIFF_TEXT = 2;
  public static final int AUTHOR = 3;
  public static final int CHANGE_DATE = 4;
  public static final int CHANGE_TIME = 5;

}
