﻿package com.hamaf.hikyakucms.sample.wiki.dto;

import com.hamaf.hikyaku.dataobject.DetailItemsBase;
import com.hamaf.hikyakucms.sample.wiki.util.WikiDocument;

/**
 * <p>タイトル：WikiDocDto is .</p>
 * <p>説明：M_WIKIDOC(Wiki文書管理)の詳細取得用データオブジェクト</p>
 * <br>
 *
 * <p>著作権: Copyright ©2012/09/09</p>
 * @author @USR
 * @version 1.0
 */
public class WikiDocDto extends DetailItemsBase {

  public static final int WIKI_NO = 0;
  public static final int TITLE = 1;
  public static final int CATEGORY = 2;
  public static final int SAMMARY = 3;
  public static final int DISPLAY_FLAG = 4;
  public static final int AUTHOR = 5;
  public static final int CREATE_DATE = 6;
  public static final int CREATE_TIME = 7;
  public static final int LAST_AUTHOR = 8;
  public static final int LAST_DATE = 9;
  public static final int LAST_TIME = 10;
  public static final int RETVAL = 11;

  private String _document  = null;
  private String _chapter = "0";
  private String _section = "0";
  private WikiDocument _wdoc = null;

  public final String getDocument() {
    return _document;
  }

  public final void setDocument(String document) {
    this._document = document;
  }

  public final String getChapter() {
    return _chapter;
  }

  public final void setChapter(String chapter) {
    this._chapter = chapter;
  }

  public final String getSection() {
    return _section;
  }

  public final void setSection(String section) {
    this._section = section;
  }

  public final WikiDocument getWikiDoc() {
    return _wdoc;
  }

  public final void setWikiDoc(WikiDocument wdoc) {
    this._wdoc = wdoc;
  }

}
