package com.hamaf.business.workflow.process;

import com.hamaf.business.workflow.access.DocumentInfAccess;
import com.hamaf.business.workflow.access.VDocumentInfAccess;
import com.hamaf.business.workflow.dto.DocumentInfDto;
import com.hamaf.business.workflow.dto.VDocumentInfDto;
import com.hamaf.business.workflow.dto.VDocumentInfSearchDto;

/**
 * <p>^CgFDocumentInfProcesss is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/06</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DocumentInfProcesss {

  private DocumentInfAccess _dia = null;
  private VDocumentInfAccess _vdia = null;
  
  /**
   * Creates a new <code>DocumentInfProcesss</code> instance.
   * <br>Default Constructor
   */
  public DocumentInfProcesss() {
    _dia = new DocumentInfAccess();
    _vdia = new VDocumentInfAccess();
  }
  
  public VDocumentInfSearchDto find(VDocumentInfSearchDto disd) throws Exception {
    return (VDocumentInfSearchDto)_vdia.find(disd);
  }
  
  public VDocumentInfDto getDetail(VDocumentInfDto did) throws Exception {
    return (VDocumentInfDto)_vdia.findByPrimaryKey(did);
  }
  
  public void addNew(DocumentInfDto did) throws Exception {
    _dia.regist(did);
  }

  public void update(DocumentInfDto did) throws Exception {
    _dia.update(did);
  }
  
  public void delete(DocumentInfDto did) throws Exception {
    _dia.delete(did);
  }
}
