package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.DfAuthorizerDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.DfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFVerified is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/16</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class Verified extends StandardUpdateProcess {

  private DocumentFlowProcess _dfp = null;
  
  /**
   * Creates a new <code>Verified</code> instance.
   * <br>Default Constructor
   */
  public Verified() {
    _jim = new DfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  private final String MSG_END = "mFς݂̓o^܂B";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _dfp.registVerified((DfAuthorizerDto)dii);
    msg.setResMsg("status", "E");
    msg.setResMsg("noti", "E");
    msg.addMessage(MSG_END);
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new DfAuthorizerDto();
  }

}
